/* $Id: main.c 42 2023-04-29 03:32:24Z nishi $ */
#include <swinehub.h>

#include <swinehub/db.h>
#include <swinehub/util.h>
#include <swinehub/page.h>
#include <swinehub/config.h>

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <errno.h>

extern DBM* swinehub_token_db;
extern DBM* swinehub_user_db;
int argc;
char** argv;
char* swinehub_body;
char* swinehub_request;
char* umethod;

int main(int argc_, char** argv_){
	argc = argc_;
	argv = argv_;
	if(swinehub_db_init() == -1) return 0;
	swinehub_body = malloc(1);
	swinehub_body[0] = 0;
	fseek(stdin, 0, SEEK_SET);
	char* buf = malloc(2);
	buf[1] = 0;
	int ch;
	if(!feof(stdin)){
		while((ch = fgetc(stdin)) != EOF){
			buf[0] = (char)ch;
			char* tmp = swinehub_body;
			swinehub_body = sstrcat(tmp, buf);
			free(tmp);
		}
	}
	free(buf);
	umethod = getenv("REQUEST_METHOD");
	setenv("ISAUTH", "NO", 1);
	setenv("ISDAV", "NO", 1);
	swinehub_request = swinehub_get_request();
	char* replaced = strdup(getenv("PATH_INFO") == NULL ? "/" : getenv("PATH_INFO"));
	int i;
	for(i = 0; replaced[i] != 0; i++){
		if(replaced[i] == ' ') replaced[i] = '-';
	}
	if(replaced[strlen(replaced) - 1] == '/' && strcmp(replaced, "/") != 0) replaced[strlen(replaced) - 1] = 0;
	setenv("PATH_REPLACED", replaced, 1);
	char* str = getenv("PATH_REPLACED");
	char* result = malloc(1);
	result[0] = 0;
	int count = 0;
	buf = malloc(2);
	buf[1] = 0;
	for(i = 0; str[i] != 0; i++){
		buf[0] = str[i];
		if(str[i] == '/'){
			count++;
		}
		if(count == 0 || count == 1){
			char* tmp = result;
			result = sstrcat(tmp, buf);
			free(tmp);
		}
		if(count == 2) break;
	}
	free(buf);
	setenv("FIRST_PATH", result, 1);
	if(getenv("PATH_INFO") != NULL){
		if(strcmp(getenv("FIRST_PATH"), "/v1") != 0 && getenv("PATH_INFO")[strlen(getenv("PATH_INFO")) - 1] != '/' && strcmp(getenv("ISDAV"), "NO") == 0){
			printf("Status: 307 Temporary Redirect\r\n");
			int incr = 1;
			if(getenv("PATH_INFO")[0] != '/') incr = 0;
			printf("Location: %s/%s/\r\n", getenv("SCRIPT_NAME"), getenv("PATH_INFO") + incr);
			printf("\r\n");
			return 0;
		}
	}
	struct swinehub_config* config = swinehub_parse_config(SWINEHUB_CONFIG);
	swinehub_create_page(config);
	swinehub_free_config(config);
	dbm_close(swinehub_user_db);
	dbm_close(swinehub_token_db);
}
