/* $Id: user.c 92 2023-05-17 18:02:01Z nishi $ */
#include <swinehub/user.h>

#include <swinehub.h>
#include <swinehub/config.h>
#include <swinehub/repo.h>
#include <swinehub/util.h>
#include <swinehub/language.h>
#include <swinehub/db.h>

#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>

EXTERN_DB;

void swinehub_user(struct swinehub_config* config){
	if(swinehub_check_repo(config) != 1){
		printf("User does not exist.\n");
	}else{
		char* user_or_team = NULL;
		datum key;
		key.dptr = getenv("PATH_REPLACED") + 2;
		key.dsize = strlen(getenv("PATH_REPLACED") + 2) + 1;
		datum user = dbm_fetch(swinehub_user_db, key);
		struct swinehub_user* s_user = (struct swinehub_user*)user.dptr;
		if(s_user->isteam == 1){
			user_or_team = strdup(SW_TEAM);
		}else{
			user_or_team = strdup(SW_USER);
		}
		SW_USER_TITLE;
		printf("<hr>\n");
		int count = 0;
		DIR* dir = opendir(config->path);
		char* result = malloc(1);
		result[0] = 0;
		if(dir != NULL){
			struct dirent* d;
			char* cmp = sstrcat(getenv("PATH_REPLACED") + 2, "-");
			while((d = readdir(dir)) != NULL){
				if(strcmp(d->d_name, ".") == 0 || strcmp(d->d_name, "..") == 0) continue;
				if(strlen(d->d_name) < strlen(cmp)) continue;
				char* tmp = strdup(d->d_name);
				tmp[strlen(cmp)] = 0;
				if(strcmp(tmp, cmp) == 0){
					char* tmpstr = result;
					char* name = sstrcat4("~", getenv("PATH_REPLACED") + 2, "/", d->d_name + strlen(cmp));
					char* link = sstrcat3(getenv("SCRIPT_NAME"), "/", name);
					char* content = sstrcat3(user_or_team, "</span><b>/</b><span>", name);
					result = sstrcat6(tmpstr, "<a href=\"", link, "\"><span>",  content, "</span></a>\n");
					free(link);
					free(name);
					free(content);
					count++;
				}
				free(tmp);
			}
			free(cmp);
			closedir(dir);
		}
		SW_USER_HAS;
		printf("<div id='repositories' class='widthfloat'>\n");
		printf("%s\n", result);
		printf("</div>\n");
		free(result);
		free(user_or_team);
	}
}
